diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.36/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.35/src/wifi/model/he/rr-multi-user-scheduler.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/he/rr-multi-user-scheduler.cc	2022-04-30 18:23:58.206735100 -0700
@@ -91,7 +91,6 @@
 }
 
 RrMultiUserScheduler::RrMultiUserScheduler ()
-  : m_ulTriggerType (TriggerFrameType::BASIC_TRIGGER)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -123,7 +122,6 @@
   NS_LOG_FUNCTION (this);
   m_staList.clear ();
   m_candidates.clear ();
-  m_trigger = nullptr;
   m_txParams.Clear ();
   m_apMac->TraceDisconnectWithoutContext ("AssociatedSta",
                                           MakeCallback (&RrMultiUserScheduler::NotifyStationAssociated, this));
@@ -150,7 +148,7 @@
     }
 
   if (m_enableUlOfdma && (GetLastTxFormat () == DL_MU_TX
-                          || m_ulTriggerType == TriggerFrameType::BSRP_TRIGGER))
+                          || m_trigger.GetType () == TriggerFrameType::BSRP_TRIGGER))
     {
       TxFormat txFormat = TrySendingBasicTf ();
 
@@ -168,28 +166,28 @@
 {
   NS_LOG_FUNCTION (this);
 
-  CtrlTriggerHeader trigger (TriggerFrameType::BSRP_TRIGGER, GetDlMuInfo ().txParams.m_txVector);
+  m_trigger = CtrlTriggerHeader (TriggerFrameType::BSRP_TRIGGER, GetDlMuInfo ().txParams.m_txVector);
 
   WifiTxVector txVector = GetDlMuInfo ().txParams.m_txVector;
-  txVector.SetGuardInterval (trigger.GetGuardInterval ());
+  txVector.SetGuardInterval (m_trigger.GetGuardInterval ());
 
   Ptr<Packet> packet = Create<Packet> ();
-  packet->AddHeader (trigger);
+  packet->AddHeader (m_trigger);
 
   Mac48Address receiver = Mac48Address::GetBroadcast ();
-  if (trigger.GetNUserInfoFields () == 1)
+  if (m_trigger.GetNUserInfoFields () == 1)
     {
-      NS_ASSERT (m_apMac->GetStaList ().find (trigger.begin ()->GetAid12 ()) != m_apMac->GetStaList ().end ());
-      receiver = m_apMac->GetStaList ().at (trigger.begin ()->GetAid12 ());
+      NS_ASSERT (m_apMac->GetStaList ().find (m_trigger.begin ()->GetAid12 ()) != m_apMac->GetStaList ().end ());
+      receiver = m_apMac->GetStaList ().at (m_trigger.begin ()->GetAid12 ());
     }
 
-  WifiMacHeader hdr (WIFI_MAC_CTL_TRIGGER);
-  hdr.SetAddr1 (receiver);
-  hdr.SetAddr2 (m_apMac->GetAddress ());
-  hdr.SetDsNotTo ();
-  hdr.SetDsNotFrom ();
+  m_triggerMacHdr = WifiMacHeader (WIFI_MAC_CTL_TRIGGER);
+  m_triggerMacHdr.SetAddr1 (receiver);
+  m_triggerMacHdr.SetAddr2 (m_apMac->GetAddress ());
+  m_triggerMacHdr.SetDsNotTo ();
+  m_triggerMacHdr.SetDsNotFrom ();
 
-  Ptr<WifiMacQueueItem> item = Create<WifiMacQueueItem> (packet, hdr);
+  Ptr<WifiMacQueueItem> item = Create<WifiMacQueueItem> (packet, m_triggerMacHdr);
 
   m_txParams.Clear ();
   // set the TXVECTOR used to send the Trigger Frame
@@ -206,7 +204,7 @@
 
   // Compute the time taken by each station to transmit 8 QoS Null frames
   Time qosNullTxDuration = Seconds (0);
-  for (const auto& userInfo : trigger)
+  for (const auto& userInfo : m_trigger)
     {
       Time duration = WifiPhy::CalculateTxDuration (m_sizeOf8QosNull, txVector,
                                                     m_apMac->GetWifiPhy ()->GetPhyBand (),
@@ -232,18 +230,12 @@
         }
     }
 
+  uint16_t ulLength;
+  std::tie (ulLength, qosNullTxDuration) = HePhy::ConvertHeTbPpduDurationToLSigLength (qosNullTxDuration,
+                                                                                       m_trigger.GetHeTbTxVector (m_trigger.begin ()->GetAid12 ()),
+                                                                                       m_apMac->GetWifiPhy ()->GetPhyBand ());
   NS_LOG_DEBUG ("Duration of QoS Null frames: " << qosNullTxDuration.As (Time::MS));
-  trigger.SetUlLength (HePhy::ConvertHeTbPpduDurationToLSigLength (qosNullTxDuration,
-                                                                    m_apMac->GetWifiPhy ()->GetPhyBand ()));
-  trigger.SetCsRequired (true);
-  m_heFem->SetTargetRssi (trigger);
-
-  packet = Create<Packet> ();
-  packet->AddHeader (trigger);
-  m_trigger = Create<WifiMacQueueItem> (packet, hdr);
-
-  m_ulTriggerType = TriggerFrameType::BSRP_TRIGGER;
-  m_tbPpduDuration = qosNullTxDuration;
+  m_trigger.SetUlLength (ulLength);
 
   return UL_MU_TX;
 }
@@ -327,18 +319,15 @@
         }
       else
         {
-          CtrlTriggerHeader trigger;
-          GetUlMuInfo ().trigger->GetPacket ()->PeekHeader (trigger);
-
-          txVector.SetChannelWidth (trigger.GetUlBandwidth ());
-          txVector.SetGuardInterval (trigger.GetGuardInterval ());
+          txVector.SetChannelWidth (GetUlMuInfo ().trigger.GetUlBandwidth ());
+          txVector.SetGuardInterval (GetUlMuInfo ().trigger.GetGuardInterval ());
 
           for (std::size_t i = 0; i < count + nCentral26TonesRus; i++)
             {
               NS_ASSERT (candidateIt != ulCandidates.end ());
               uint16_t staId = candidateIt->second.first->aid;
-              auto userInfoIt = trigger.FindUserInfoWithAid (staId);
-              NS_ASSERT (userInfoIt != trigger.end ());
+              auto userInfoIt = GetUlMuInfo ().trigger.FindUserInfoWithAid (staId);
+              NS_ASSERT (userInfoIt != GetUlMuInfo ().trigger.end ());
               // AssignRuIndices will be called below to set RuSpec
               txVector.SetHeMuUserInfo (staId,
                                         {{(i < count ? ruType : HeRu::RU_26_TONE), 1, false},
@@ -353,9 +342,9 @@
       ulCandidates.erase (candidateIt, ulCandidates.end ());
       AssignRuIndices (txVector);
 
-      CtrlTriggerHeader trigger (TriggerFrameType::BASIC_TRIGGER, txVector);
+      m_trigger = CtrlTriggerHeader (TriggerFrameType::BASIC_TRIGGER, txVector);
       Ptr<Packet> packet = Create<Packet> ();
-      packet->AddHeader (trigger);
+      packet->AddHeader (m_trigger);
 
       Mac48Address receiver = Mac48Address::GetBroadcast ();
       if (ulCandidates.size () == 1)
@@ -363,13 +352,13 @@
           receiver = ulCandidates.begin ()->second.first->address;
         }
 
-      WifiMacHeader hdr (WIFI_MAC_CTL_TRIGGER);
-      hdr.SetAddr1 (receiver);
-      hdr.SetAddr2 (m_apMac->GetAddress ());
-      hdr.SetDsNotTo ();
-      hdr.SetDsNotFrom ();
+      m_triggerMacHdr = WifiMacHeader (WIFI_MAC_CTL_TRIGGER);
+      m_triggerMacHdr.SetAddr1 (receiver);
+      m_triggerMacHdr.SetAddr2 (m_apMac->GetAddress ());
+      m_triggerMacHdr.SetDsNotTo ();
+      m_triggerMacHdr.SetDsNotFrom ();
 
-      Ptr<WifiMacQueueItem> item = Create<WifiMacQueueItem> (packet, hdr);
+      Ptr<WifiMacQueueItem> item = Create<WifiMacQueueItem> (packet, m_triggerMacHdr);
 
       // compute the maximum amount of time that can be granted to stations.
       // This value is limited by the max PPDU duration
@@ -409,7 +398,7 @@
 
       // Compute the time taken by each station to transmit a frame of maxBufferSize size
       Time bufferTxTime = Seconds (0);
-      for (const auto& userInfo : trigger)
+      for (const auto& userInfo : m_trigger)
         {
           Time duration = WifiPhy::CalculateTxDuration (maxBufferSize, txVector,
                                                         m_apMac->GetWifiPhy ()->GetPhyBand (),
@@ -427,7 +416,7 @@
           // maxDuration may be a too short time. If it does not allow any station to
           // transmit at least m_ulPsduSize bytes, give up the UL MU transmission for now
           Time minDuration = Seconds (0);
-          for (const auto& userInfo : trigger)
+          for (const auto& userInfo : m_trigger)
             {
               Time duration = WifiPhy::CalculateTxDuration (m_ulPsduSize, txVector,
                                                             m_apMac->GetWifiPhy ()->GetPhyBand (),
@@ -446,24 +435,18 @@
         }
 
       // maxDuration is the time to grant to the stations. Finalize the Trigger Frame
+      uint16_t ulLength;
+      std::tie (ulLength, maxDuration) = HePhy::ConvertHeTbPpduDurationToLSigLength (maxDuration,
+                                                                                     txVector,
+                                                                                     m_apMac->GetWifiPhy ()->GetPhyBand ());
       NS_LOG_DEBUG ("TB PPDU duration: " << maxDuration.As (Time::MS));
-      trigger.SetUlLength (HePhy::ConvertHeTbPpduDurationToLSigLength (maxDuration,
-                                                                       m_apMac->GetWifiPhy ()->GetPhyBand ()));
-      trigger.SetCsRequired (true);
-      m_heFem->SetTargetRssi (trigger);
+      m_trigger.SetUlLength (ulLength);
       // set Preferred AC to the AC that gained channel access
-      for (auto& userInfo : trigger)
+      for (auto& userInfo : m_trigger)
         {
           userInfo.SetBasicTriggerDepUserInfo (0, 0, m_edca->GetAccessCategory ());
         }
 
-      packet = Create<Packet> ();
-      packet->AddHeader (trigger);
-      m_trigger = Create<WifiMacQueueItem> (packet, hdr);
-
-      m_ulTriggerType = TriggerFrameType::BASIC_TRIGGER;
-      m_tbPpduDuration = maxDuration;
-
       return UL_MU_TX;
     }
   return DL_MU_TX;
@@ -708,8 +691,7 @@
       mpdu = candidate.second;
       NS_ASSERT (mpdu != nullptr);
 
-      bool ret = m_heFem->TryAddMpdu (mpdu, dlMuInfo.txParams, actualAvailableTime);
-      NS_UNUSED (ret);
+      [[maybe_unused]] bool ret = m_heFem->TryAddMpdu (mpdu, dlMuInfo.txParams, actualAvailableTime);
       NS_ASSERT_MSG (ret, "Weird that an MPDU does not meet constraints when "
                           "transmitted over a larger RU");
     }
@@ -728,26 +710,24 @@
       NS_ASSERT (receiver == candidate.first->address);
 
       NS_ASSERT (mpdu->IsQueued ());
-      WifiMacQueueItem::ConstIterator queueIt = mpdu->GetQueueIterator ();
-      Ptr<WifiMacQueueItem> item = *queueIt;
-      queueIt++;
+      Ptr<WifiMacQueueItem> item = mpdu->GetItem ();
 
       if (!mpdu->GetHeader ().IsRetry ())
         {
           // this MPDU must have been dequeued from the AC queue and we can try
           // A-MSDU aggregation
-          item = m_heFem->GetMsduAggregator ()->GetNextAmsdu (mpdu, dlMuInfo.txParams, m_availableTime, queueIt);
+          item = m_heFem->GetMsduAggregator ()->GetNextAmsdu (mpdu, dlMuInfo.txParams, m_availableTime);
 
           if (item == nullptr)
             {
               // A-MSDU aggregation failed or disabled
-              item = *mpdu->GetQueueIterator ();
+              item = mpdu->GetItem ();
             }
           m_apMac->GetQosTxop (QosUtilsMapTidToAc (tid))->AssignSequenceNumber (item);
         }
 
       // Now, let's try A-MPDU aggregation if possible
-      std::vector<Ptr<WifiMacQueueItem>> mpduList = m_heFem->GetMpduAggregator ()->GetNextAmpdu (item, dlMuInfo.txParams, m_availableTime, queueIt);
+      std::vector<Ptr<WifiMacQueueItem>> mpduList = m_heFem->GetMpduAggregator ()->GetNextAmpdu (item, dlMuInfo.txParams, m_availableTime);
 
       if (mpduList.size () > 1)
         {
@@ -852,7 +832,7 @@
 MultiUserScheduler::UlMuInfo
 RrMultiUserScheduler::ComputeUlMuInfo (void)
 {
-  return UlMuInfo {m_trigger, m_tbPpduDuration, std::move (m_txParams)};
+  return UlMuInfo {m_trigger, m_triggerMacHdr, std::move (m_txParams)};
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/he/rr-multi-user-scheduler.h ns-3.36/src/wifi/model/he/rr-multi-user-scheduler.h
--- ns-3.35/src/wifi/model/he/rr-multi-user-scheduler.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/he/rr-multi-user-scheduler.h	2022-04-30 18:23:58.206735100 -0700
@@ -134,10 +134,9 @@
   std::map<AcIndex, std::list<MasterInfo>> m_staList;   //!< Per-AC list of stations (next to serve first)
   std::list<CandidateInfo> m_candidates;                //!< Candidate stations for MU TX
   Time m_maxCredits;                                    //!< Max amount of credits a station can have
-  Ptr<WifiMacQueueItem> m_trigger;                      //!< Trigger Frame to send
-  Time m_tbPpduDuration;                                //!< Duration of the solicited TB PPDUs
+  CtrlTriggerHeader m_trigger;                          //!< Trigger Frame to send
+  WifiMacHeader m_triggerMacHdr;                        //!< MAC header for Trigger Frame
   WifiTxParameters m_txParams;                          //!< TX parameters
-  TriggerFrameType m_ulTriggerType;                     //!< Trigger Frame type for UL MU
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.36/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ht/ht-frame-exchange-manager.cc	2022-04-30 18:23:58.206735100 -0700
@@ -75,7 +75,7 @@
 }
 
 void
-HtFrameExchangeManager::SetWifiMac (const Ptr<RegularWifiMac> mac)
+HtFrameExchangeManager::SetWifiMac (const Ptr<WifiMac> mac)
 {
   m_msduAggregator->SetWifiMac (mac);
   m_mpduAggregator->SetWifiMac (mac);
@@ -185,7 +185,12 @@
   txParams.m_acknowledgment = GetAckManager ()->TryAddMpdu (mpdu, txParams);
 
   // Push the MPDU to the front of the queue and transmit it
-  m_mac->GetQosTxop (tid)->GetWifiMacQueue ()->PushFront (mpdu);
+  auto queue = m_mac->GetQosTxop (tid)->GetWifiMacQueue ();
+  if (!queue->PushFront (mpdu))
+    {
+      NS_LOG_DEBUG ("Queue is full, replace the oldest frame with the ADDBA Request frame");
+      queue->Replace (queue->Peek (), mpdu);
+    }
   SendMpduWithProtection (mpdu, txParams);
 }
 
@@ -219,7 +224,7 @@
     }
   respHdr.SetTid (reqHdr->GetTid ());
 
-  respHdr.SetBufferSize (GetSupportedBaBufferSize () - 1);
+  respHdr.SetBufferSize (GetSupportedBaBufferSize ());
   respHdr.SetTimeout (reqHdr->GetTimeout ());
 
   WifiActionHeader actionHdr;
@@ -288,9 +293,9 @@
 {
   NS_LOG_FUNCTION (this << *respHdr << originator << startingSeq);
   uint8_t tid = respHdr->GetTid ();
-  
+
   RecipientBlockAckAgreement agreement (originator, respHdr->IsAmsduSupported (), tid,
-                                        respHdr->GetBufferSize () + 1, respHdr->GetTimeout (),
+                                        respHdr->GetBufferSize (), respHdr->GetTimeout (),
                                         startingSeq,
                                         m_mac->GetWifiRemoteStationManager ()->GetHtSupported ()
                                         && m_mac->GetWifiRemoteStationManager ()->GetHtSupported (originator));
@@ -313,7 +318,6 @@
     }
 
   m_agreements.insert ({{originator, tid}, agreement});
-  GetBaManager (tid)->SetBlockAckInactivityCallback (MakeCallback (&HtFrameExchangeManager::SendDelbaFrame, this));
 }
 
 void
@@ -431,7 +435,7 @@
 
   // we can transmit the BlockAckReq frame
   Ptr<const WifiMacQueueItem> mpdu = edca->GetBaManager ()->GetBar ();
-  SendPsduWithProtection (Create<WifiPsdu> (mpdu, false), txParams);
+  SendPsduWithProtection (GetWifiPsdu (Copy (mpdu), txParams.m_txVector), txParams);
   return true;
 }
 
@@ -447,8 +451,7 @@
   Ptr<QosTxop> edca = m_mac->GetQosTxop (peekedItem->GetHeader ().GetQosTid ());
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peekedItem->GetHeader ());
-  WifiMacQueueItem::ConstIterator queueIt;
-  Ptr<WifiMacQueueItem> mpdu = edca->GetNextMpdu (peekedItem, txParams, availableTime, initialFrame, queueIt);
+  Ptr<WifiMacQueueItem> mpdu = edca->GetNextMpdu (peekedItem, txParams, availableTime, initialFrame);
 
   if (mpdu == nullptr)
     {
@@ -458,7 +461,7 @@
 
   // try A-MPDU aggregation
   std::vector<Ptr<WifiMacQueueItem>> mpduList = m_mpduAggregator->GetNextAmpdu (mpdu, txParams,
-                                                                                availableTime, queueIt);
+                                                                                availableTime);
   NS_ASSERT (txParams.m_acknowledgment);
 
   if (mpduList.size () > 1)
@@ -650,7 +653,7 @@
 }
 
 void
-HtFrameExchangeManager::RetransmitMpduAfterMissedCts (Ptr<WifiMacQueueItem> mpdu) const
+HtFrameExchangeManager::ReleaseSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const
 {
   NS_LOG_FUNCTION (this << *mpdu);
 
@@ -679,7 +682,7 @@
           return;
         }
     }
-  QosFrameExchangeManager::RetransmitMpduAfterMissedCts (mpdu);
+  QosFrameExchangeManager::ReleaseSequenceNumber (mpdu);
 }
 
 Time
@@ -765,32 +768,8 @@
       return;
     }
 
-  NS_ASSERT (m_psdu->GetNMpdus () > 1);
-  m_mac->GetWifiRemoteStationManager ()->ReportRtsFailed (m_psdu->GetHeader (0));
-
-  if (!m_mac->GetWifiRemoteStationManager ()->NeedRetransmission (*m_psdu->begin ()))
-    {
-      NS_LOG_DEBUG ("Missed CTS, discard MPDUs");
-      m_mac->GetWifiRemoteStationManager ()->ReportFinalRtsFailed (m_psdu->GetHeader (0));
-      // Dequeue the MPDUs if they are stored in a queue
-      DequeuePsdu (m_psdu);
-      for (const auto& mpdu : *PeekPointer (m_psdu))
-        {
-          NotifyPacketDiscarded (mpdu);
-        }
-      m_edca->ResetCw ();
-    }
-  else
-    {
-      NS_LOG_DEBUG ("Missed CTS, retransmit MPDUs");
-      for (const auto& mpdu : *PeekPointer (m_psdu))
-        {
-          RetransmitMpduAfterMissedCts (mpdu);
-        }
-      m_edca->UpdateFailedCw ();
-    }
-  m_psdu = 0;
-  TransmissionFailed ();
+  DoCtsTimeout (m_psdu);
+  m_psdu = nullptr;
 }
 
 void
@@ -942,7 +921,7 @@
 {
   NS_ASSERT (mpdu != 0);
   NS_LOG_FUNCTION (this << *mpdu << &txParams << ppduDurationLimit);
-  
+
   Mac48Address receiver = mpdu->GetHeader ().GetAddr1 ();
   uint32_t ampduSize = txParams.GetSizeIfAddMpdu (mpdu);
 
@@ -1362,7 +1341,7 @@
           mpdu->GetPacket ()->PeekHeader (blockAckReq);
           NS_ABORT_MSG_IF (blockAckReq.IsMultiTid (), "Multi-TID BlockAckReq not supported");
           uint8_t tid = blockAckReq.GetTidInfo ();
-          
+
           auto agreementIt = m_agreements.find ({sender, tid});
 
           if (agreementIt == m_agreements.end ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.h ns-3.36/src/wifi/model/ht/ht-frame-exchange-manager.h
--- ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ht/ht-frame-exchange-manager.h	2022-04-30 18:23:58.206735100 -0700
@@ -60,7 +60,7 @@
   virtual ~HtFrameExchangeManager ();
 
   bool StartFrameExchange (Ptr<QosTxop> edca, Time availableTime, bool initialFrame) override;
-  void SetWifiMac (const Ptr<RegularWifiMac> mac) override;
+  void SetWifiMac (const Ptr<WifiMac> mac) override;
   void CalculateAcknowledgmentTime (WifiAcknowledgment* acknowledgment) const override;
 
   /**
@@ -145,7 +145,7 @@
    * \param startingSeq Sequence number of the first MPDU of all
    *        packets for which block ack was negotiated.
    *
-   * This function is typically invoked only by ns3::RegularWifiMac
+   * This function is typically invoked only by ns3::WifiMac
    * when the STA (which may be non-AP in ESS, or in an IBSS) has
    * received an ADDBA Request frame and is transmitting an ADDBA
    * Response frame. At this point the frame exchange manager must
@@ -198,6 +198,16 @@
    */
   BlockAckType GetBlockAckType (Mac48Address originator, uint8_t tid) const;
 
+  /**
+   * Sends DELBA frame to cancel a block ack agreement with STA
+   * addressed by <i>addr</i> for TID <i>tid</i>.
+   *
+   * \param addr address of the recipient.
+   * \param tid traffic ID.
+   * \param byOriginator flag to indicate whether this is set by the originator.
+   */
+  void SendDelbaFrame (Mac48Address addr, uint8_t tid, bool byOriginator);
+
 protected:
   void DoDispose () override;
 
@@ -208,7 +218,7 @@
   void NotifyReceivedNormalAck (Ptr<WifiMacQueueItem> mpdu) override;
   void NotifyPacketDiscarded (Ptr<const WifiMacQueueItem> mpdu) override;
   void RetransmitMpduAfterMissedAck (Ptr<WifiMacQueueItem> mpdu) const override;
-  void RetransmitMpduAfterMissedCts (Ptr<WifiMacQueueItem> mpdu) const override;
+  void ReleaseSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const override;
   void ForwardMpduDown (Ptr<WifiMacQueueItem> mpdu, WifiTxVector& txVector) override;
   void CtsTimeout (Ptr<WifiMacQueueItem> rts, const WifiTxVector& txVector) override;
   void TransmissionSucceeded (void) override;
@@ -335,16 +345,6 @@
                          uint16_t timeout, bool immediateBAck);
 
   /**
-   * Sends DELBA frame to cancel a block ack agreement with STA
-   * addressed by <i>addr</i> for TID <i>tid</i>.
-   *
-   * \param addr address of the recipient.
-   * \param tid traffic ID.
-   * \param byOriginator flag to indicate whether this is set by the originator.
-   */
-  void SendDelbaFrame (Mac48Address addr, uint8_t tid, bool byOriginator);
-
-  /**
    * Create a BlockAck frame with header equal to <i>blockAck</i> and start its transmission.
    *
    * \param agreement the agreement the Block Ack response belongs to
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ht/ht-phy.cc ns-3.36/src/wifi/model/ht/ht-phy.cc
--- ns-3.35/src/wifi/model/ht/ht-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ht/ht-phy.cc	2022-04-30 18:23:58.206735100 -0700
@@ -549,14 +549,13 @@
   return WifiModeFactory::CreateWifiMcs ("HtMcs" + std::to_string (index),
                                          index,
                                          WIFI_MOD_CLASS_HT,
+                                         false,
                                          MakeBoundCallback (&GetHtCodeRate, index),
                                          MakeBoundCallback (&GetHtConstellationSize, index),
-                                         MakeBoundCallback (&GetPhyRate, index),
                                          MakeCallback (&GetPhyRateFromTxVector),
-                                         MakeBoundCallback (&GetDataRate, index),
                                          MakeCallback (&GetDataRateFromTxVector),
                                          MakeBoundCallback (&GetNonHtReferenceRate, index),
-                                         MakeCallback (&IsModeAllowed));
+                                         MakeCallback (&IsAllowed));
 }
 
 WifiCodeRate
@@ -763,7 +762,7 @@
 }
 
 bool
-HtPhy::IsModeAllowed (uint16_t /* channelWidth */, uint8_t /* nss */)
+HtPhy::IsAllowed (const WifiTxVector& /*txVector*/)
 {
   return true;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ht/ht-phy.h ns-3.36/src/wifi/model/ht/ht-phy.h
--- ns-3.35/src/wifi/model/ht/ht-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ht/ht-phy.h	2022-04-30 18:23:58.206735100 -0700
@@ -437,15 +437,13 @@
    */
   static uint64_t GetNonHtReferenceRate (uint8_t mcsValue);
   /**
-   * Check whether the combination of <MCS, channel width, NSS> is allowed.
-   * This function is used as a callback for WifiMode operation, and always
-   * returns true since there is no limitation for any MCS in HtPhy.
+   * Check whether the combination in TXVECTOR is allowed.
+   * This function is used as a callback for WifiMode operation.
    *
-   * \param channelWidth the considered channel width in MHz
-   * \param nss the considered number of streams
-   * \returns true.
+   * \param txVector the TXVECTOR
+   * \returns true if this combination is allowed, false otherwise.
    */
-  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+  static bool IsAllowed (const WifiTxVector& txVector);
 
 protected:
   PhyFieldRxStatus DoEndReceiveField (WifiPpduField field, Ptr<Event> event) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ht/ht-ppdu.cc ns-3.36/src/wifi/model/ht/ht-ppdu.cc
--- ns-3.35/src/wifi/model/ht/ht-ppdu.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ht/ht-ppdu.cc	2022-04-30 18:23:58.206735100 -0700
@@ -174,7 +174,7 @@
 bool
 HtPpdu::HtSigHeader::GetAggregation (void) const
 {
-  return m_aggregation ? true : false;
+  return m_aggregation;
 }
 
 void
@@ -186,7 +186,7 @@
 bool
 HtPpdu::HtSigHeader::GetShortGuardInterval (void) const
 {
-  return m_sgi ? true : false;
+  return m_sgi;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/interference-helper.cc ns-3.36/src/wifi/model/interference-helper.cc
--- ns-3.35/src/wifi/model/interference-helper.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/interference-helper.cc	2022-04-30 18:23:58.206735100 -0700
@@ -422,8 +422,8 @@
 {
   NS_LOG_FUNCTION (this << channelWidth << band.first << band.second << staId << window.first << window.second);
   double psr = 1.0; /* Packet Success Rate */
-  auto niIt = nis->find (band)->second;
-  auto j = niIt.begin ();
+  const auto& niIt = nis->find (band)->second;
+  auto j = niIt.cbegin ();
   Time previous = j->first;
   WifiMode payloadMode = event->GetTxVector ().GetMode (staId);
   Time phyPayloadStart = j->first;
@@ -435,7 +435,7 @@
   Time windowEnd = phyPayloadStart + window.second;
   double noiseInterferenceW = m_firstPowerPerBand.find (band)->second;
   double powerW = event->GetRxPowerW (band);
-  while (++j != niIt.end ())
+  while (++j != niIt.cend ())
     {
       Time current = j->first;
       NS_LOG_DEBUG ("previous= " << previous << ", current=" << current);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/mgt-headers.cc ns-3.36/src/wifi/model/mgt-headers.cc
--- ns-3.35/src/wifi/model/mgt-headers.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/mgt-headers.cc	2022-04-30 18:23:58.206735100 -0700
@@ -1581,7 +1581,7 @@
 bool
 MgtAddBaRequestHeader::IsImmediateBlockAck (void) const
 {
-  return (m_policy == 1) ? true : false;
+  return m_policy == 1;
 }
 
 uint16_t
@@ -1599,7 +1599,7 @@
 bool
 MgtAddBaRequestHeader::IsAmsduSupported (void) const
 {
-  return (m_amsduSupport == 1) ? true : false;
+  return m_amsduSupport == 1;
 }
 
 uint16_t
@@ -1761,7 +1761,7 @@
 bool
 MgtAddBaResponseHeader::IsImmediateBlockAck (void) const
 {
-  return (m_policy == 1) ? true : false;
+  return m_policy == 1;
 }
 
 uint16_t
@@ -1779,7 +1779,7 @@
 bool
 MgtAddBaResponseHeader::IsAmsduSupported (void) const
 {
-  return (m_amsduSupport == 1) ? true : false;
+  return m_amsduSupport == 1;
 }
 
 uint16_t
@@ -1865,7 +1865,7 @@
 bool
 MgtDelBaHeader::IsByOriginator (void) const
 {
-  return (m_initiator == 1) ? true : false;
+  return m_initiator == 1;
 }
 
 uint8_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/mpdu-aggregator.cc ns-3.36/src/wifi/model/mpdu-aggregator.cc
--- ns-3.35/src/wifi/model/mpdu-aggregator.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/mpdu-aggregator.cc	2022-04-30 18:23:58.210735000 -0700
@@ -33,7 +33,8 @@
 #include "ns3/ht-capabilities.h"
 #include "ns3/vht-capabilities.h"
 #include "ns3/he-capabilities.h"
-#include "regular-wifi-mac.h"
+#include "wifi-mac.h"
+#include "qos-txop.h"
 #include "ctrl-headers.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-tx-parameters.h"
@@ -71,7 +72,7 @@
 }
 
 void
-MpduAggregator::SetWifiMac (const Ptr<RegularWifiMac> mac)
+MpduAggregator::SetWifiMac (const Ptr<WifiMac> mac)
 {
   NS_LOG_FUNCTION (this << mac);
   m_mac = mac;
@@ -192,7 +193,7 @@
 
 std::vector<Ptr<WifiMacQueueItem>>
 MpduAggregator::GetNextAmpdu (Ptr<WifiMacQueueItem> mpdu, WifiTxParameters& txParams,
-                              Time availableTime, WifiMacQueueItem::ConstIterator queueIt) const
+                              Time availableTime) const
 {
   NS_LOG_FUNCTION (this << *mpdu << &txParams << availableTime);
 
@@ -222,10 +223,10 @@
           mpduList.push_back (nextMpdu);
 
           // If allowed by the BA agreement, get the next MPDU
+          Ptr<const WifiMacQueueItem> peekedMpdu;
+          peekedMpdu = qosTxop->PeekNextMpdu (tid, recipient, nextMpdu);
           nextMpdu = 0;
 
-          Ptr<const WifiMacQueueItem> peekedMpdu;
-          peekedMpdu = qosTxop->PeekNextMpdu (queueIt, tid, recipient);
           if (peekedMpdu != 0)
             {
               // PeekNextMpdu() does not return an MPDU that is beyond the transmit window
@@ -237,7 +238,7 @@
               // and duration limit are met. Note that the returned MPDU differs from
               // the peeked MPDU if A-MSDU aggregation is enabled.
               NS_LOG_DEBUG ("Trying to aggregate another MPDU");
-              nextMpdu = qosTxop->GetNextMpdu (peekedMpdu, txParams, availableTime, false, queueIt);
+              nextMpdu = qosTxop->GetNextMpdu (peekedMpdu, txParams, availableTime, false);
             }
         }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/mpdu-aggregator.h ns-3.36/src/wifi/model/mpdu-aggregator.h
--- ns-3.35/src/wifi/model/mpdu-aggregator.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/mpdu-aggregator.h	2022-04-30 18:23:58.210735000 -0700
@@ -23,7 +23,7 @@
 
 #include "ns3/object.h"
 #include "wifi-mode.h"
-#include "qos-txop.h"
+#include "wifi-mac-queue-item.h"
 #include "ns3/nstime.h"
 #include <vector>
 
@@ -31,9 +31,9 @@
 
 class AmpduSubframeHeader;
 class WifiTxVector;
+class QosTxop;
 class Packet;
-class WifiMacQueueItem;
-class RegularWifiMac;
+class WifiMac;
 class WifiTxParameters;
 
 /**
@@ -118,21 +118,18 @@
    * \param mpdu the given MPDU.
    * \param txParams the TX parameters used to transmit the frame
    * \param availableTime the time available for the frame exchange
-   * \param queueIt the QueueIteratorPair pointing to the queue item from which the
-   *                search for an MPDU starts, if the QueueIteratorPair is valid
    * \return the resulting A-MPDU, if aggregation is possible.
    */
   std::vector<Ptr<WifiMacQueueItem>> GetNextAmpdu (Ptr<WifiMacQueueItem> mpdu,
                                                    WifiTxParameters& txParams,
-                                                   Time availableTime,
-                                                   WifiMacQueueItem::ConstIterator queueIt) const;
+                                                   Time availableTime) const;
 
   /**
    * Set the MAC layer to use.
    *
    * \param mac the MAC layer to use
    */
-  void SetWifiMac (const Ptr<RegularWifiMac> mac);
+  void SetWifiMac (const Ptr<WifiMac> mac);
 
   /**
    * \param ampduSize the size of the A-MPDU that needs to be padded in bytes
@@ -158,7 +155,7 @@
   void DoDispose () override;
 
 private:
-  Ptr<RegularWifiMac> m_mac;   //!< the MAC of this station
+  Ptr<WifiMac> m_mac;   //!< the MAC of this station
 };
 
 }  //namespace ns3
